import React, { useState, useCallback } from "react";
import { ThemeProvider } from "theme-ui";
import { ConfigContext, DEFAULT_THEME } from "./ConfigContext";
export default function ConfigProvider(props) {
    const { children, config: configProp } = props;
    const [config, changeConfig] = useState({
        theme: Object.assign(Object.assign({}, DEFAULT_THEME), (configProp ? configProp.theme : {})),
    });
    const setConfig = useCallback((c) => {
        changeConfig(Object.assign(Object.assign({}, config), c));
    }, [config]);
    return (React.createElement(ConfigContext.Provider, { value: { config, setConfig } },
        React.createElement(ThemeProvider, { theme: config.theme }, children)));
}
